From 9d93393d0fc47a867db399a5929b2202420e7645 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Aida=20Jonikien=C4=97?= <aidas957@gmail.com>
Date: Mon, 22 Jan 2024 15:43:35 +0200
Subject: [PATCH 4/6] Remove useless options from winecfg

These options have done nothing for a long time (and introduce a
placebo effect for inexperienced users)
---
 ...001-winecfg-Add-staging-tab-for-CSMT.patch | 14 ++--
 ...kbox-to-enable-disable-vaapi-GPU-dec.patch | 80 ------------------
 ...eckbox-to-enable-disable-EAX-support.patch | 39 +++++----
 ...kbox-to-enable-disable-HideWineExpor.patch | 33 ++++----
 ...ption-to-enable-disable-GTK3-theming.patch | 83 -------------------
 ...ut-config-options-to-a-dedicated-tab.patch | 34 ++++----
 6 files changed, 59 insertions(+), 224 deletions(-)
 delete mode 100644 patches/winecfg-Staging/0002-winecfg-Add-checkbox-to-enable-disable-vaapi-GPU-dec.patch
 delete mode 100644 patches/winecfg-Staging/0005-winecfg-Add-option-to-enable-disable-GTK3-theming.patch

diff --git a/patches/winecfg-Staging/0001-winecfg-Add-staging-tab-for-CSMT.patch b/patches/winecfg-Staging/0001-winecfg-Add-staging-tab-for-CSMT.patch
index 9fc07962..f7f8d549 100644
--- a/patches/winecfg-Staging/0001-winecfg-Add-staging-tab-for-CSMT.patch
+++ b/patches/winecfg-Staging/0001-winecfg-Add-staging-tab-for-CSMT.patch
@@ -1,7 +1,7 @@
-From e9a0e31aa2a7f70fe4074f13e6b69e0d440ea469 Mon Sep 17 00:00:00 2001
+From f1cbdde20bb2dffee6ec6b682f60f55e88310ef1 Mon Sep 17 00:00:00 2001
 From: =?UTF-8?q?Michael=20M=C3=BCller?= <michael@fds-team.de>
 Date: Sun, 14 Dec 2014 20:42:45 +0100
-Subject: [PATCH] winecfg: Add staging tab for CSMT.
+Subject: [PATCH 1/4] winecfg: Add staging tab for CSMT.
 
 ---
  programs/winecfg/Makefile.in |  1 +
@@ -26,10 +26,10 @@ index 780f0e7e183..99c829a9468 100644
  	winecfg.c \
  	winecfg.man.in \
 diff --git a/programs/winecfg/main.c b/programs/winecfg/main.c
-index d218d79770c..de5340c721f 100644
+index 2697383d781..afecfd664a9 100644
 --- a/programs/winecfg/main.c
 +++ b/programs/winecfg/main.c
-@@ -57,7 +57,7 @@ PropSheetCallback (HWND hWnd, UINT uMsg, LPARAM lParam)
+@@ -58,7 +58,7 @@ PropSheetCallback (HWND hWnd, UINT uMsg, LPARAM lParam)
      return 0;
  }
  
@@ -38,7 +38,7 @@ index d218d79770c..de5340c721f 100644
  
  static INT_PTR
  doPropertySheet (HINSTANCE hInstance, HWND hOwner)
-@@ -138,6 +138,16 @@ doPropertySheet (HINSTANCE hInstance, HWND hOwner)
+@@ -139,6 +139,16 @@ doPropertySheet (HINSTANCE hInstance, HWND hOwner)
      psp[pg].lParam = 0;
      pg++;
  
@@ -186,7 +186,7 @@ index f3f3ad2addf..d4fedff5afb 100644
  
  /* Windows version management */
 diff --git a/programs/winecfg/winecfg.rc b/programs/winecfg/winecfg.rc
-index 982e7dd262a..ef41bf45921 100644
+index 779a2f900e3..65aeb6986df 100644
 --- a/programs/winecfg/winecfg.rc
 +++ b/programs/winecfg/winecfg.rc
 @@ -38,6 +38,7 @@ BEGIN
@@ -214,5 +214,5 @@ index 982e7dd262a..ef41bf45921 100644
  
  /* @makedep: winecfg.ico */
 -- 
-2.42.0
+2.43.0
 
diff --git a/patches/winecfg-Staging/0002-winecfg-Add-checkbox-to-enable-disable-vaapi-GPU-dec.patch b/patches/winecfg-Staging/0002-winecfg-Add-checkbox-to-enable-disable-vaapi-GPU-dec.patch
deleted file mode 100644
index 89b78469..00000000
--- a/patches/winecfg-Staging/0002-winecfg-Add-checkbox-to-enable-disable-vaapi-GPU-dec.patch
+++ /dev/null
@@ -1,80 +0,0 @@
-From f9e74e7d75b84f1831e49f7be9197e3a6db6e428 Mon Sep 17 00:00:00 2001
-From: Sebastian Lackner <sebastian@fds-team.de>
-Date: Sat, 21 Feb 2015 23:37:26 +0100
-Subject: [PATCH] winecfg: Add checkbox to enable/disable vaapi GPU decoder.
-
----
- programs/winecfg/resource.h |  1 +
- programs/winecfg/staging.c  | 20 ++++++++++++++++++++
- programs/winecfg/winecfg.rc |  1 +
- 3 files changed, 22 insertions(+)
-
-diff --git a/programs/winecfg/resource.h b/programs/winecfg/resource.h
-index 582c5c967e4..17378655db6 100644
---- a/programs/winecfg/resource.h
-+++ b/programs/winecfg/resource.h
-@@ -214,6 +214,7 @@
- 
- /* Staging tab */
- #define IDC_ENABLE_CSMT                 9001
-+#define IDC_ENABLE_VAAPI                9002
- 
- /* About tab */
- #define IDC_ABT_OWNER                8432
-diff --git a/programs/winecfg/staging.c b/programs/winecfg/staging.c
-index a2a2117a56d..3ba1e618bb3 100644
---- a/programs/winecfg/staging.c
-+++ b/programs/winecfg/staging.c
-@@ -42,10 +42,26 @@ static void csmt_set(BOOL status)
-     set_reg_key_dword(config_key, L"Direct3D", L"csmt", status);
- }
- 
-+/*
-+ * DXVA2
-+ */
-+static BOOL vaapi_get(void)
-+{
-+    BOOL ret;
-+    WCHAR *value = get_reg_key(config_key, keypath(L"DXVA2"), L"backend", NULL);
-+    ret = (value && !wcscmp(value, L"va"));
-+    free(value);
-+    return ret;
-+}
-+static void vaapi_set(BOOL status)
-+{
-+    set_reg_key(config_key, keypath(L"DXVA2"), L"backend", status ? L"va" : NULL);
-+}
- 
- static void load_staging_settings(HWND dialog)
- {
-     CheckDlgButton(dialog, IDC_ENABLE_CSMT, csmt_get() ? BST_CHECKED : BST_UNCHECKED);
-+    CheckDlgButton(dialog, IDC_ENABLE_VAAPI, vaapi_get() ? BST_CHECKED : BST_UNCHECKED);
- }
- 
- INT_PTR CALLBACK StagingDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
-@@ -75,6 +91,10 @@ INT_PTR CALLBACK StagingDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lPar
-             csmt_set(IsDlgButtonChecked(hDlg, IDC_ENABLE_CSMT) == BST_CHECKED);
-             SendMessageW(GetParent(hDlg), PSM_CHANGED, 0, 0);
-             return TRUE;
-+        case IDC_ENABLE_VAAPI:
-+            vaapi_set(IsDlgButtonChecked(hDlg, IDC_ENABLE_VAAPI) == BST_CHECKED);
-+            SendMessageW(GetParent(hDlg), PSM_CHANGED, 0, 0);
-+            return TRUE;
-         }
-         break;
-     }
-diff --git a/programs/winecfg/winecfg.rc b/programs/winecfg/winecfg.rc
-index 895f68c1237..eafbdd6cd67 100644
---- a/programs/winecfg/winecfg.rc
-+++ b/programs/winecfg/winecfg.rc
-@@ -318,6 +318,7 @@ BEGIN
-     GROUPBOX    "Staging settings",IDC_STATIC,8,4,244,210
-     LTEXT       "The following settings are experimental and may break stuff!\nMake sure to reset them again in case of a problem.",IDC_STATIC,16,16,230,16
-     CONTROL     "Enable &CSMT for better graphic performance (deprecated)",IDC_ENABLE_CSMT,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,16,40,230,8
-+    CONTROL     "Enable &VAAPI as backend for DXVA2 GPU decoding",IDC_ENABLE_VAAPI,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,16,55,230,8
- END
- 
- LANGUAGE LANG_NEUTRAL, SUBLANG_NEUTRAL
--- 
-2.33.0
-
diff --git a/patches/winecfg-Staging/0003-winecfg-Add-checkbox-to-enable-disable-EAX-support.patch b/patches/winecfg-Staging/0003-winecfg-Add-checkbox-to-enable-disable-EAX-support.patch
index 06755e09..b32b6842 100644
--- a/patches/winecfg-Staging/0003-winecfg-Add-checkbox-to-enable-disable-EAX-support.patch
+++ b/patches/winecfg-Staging/0003-winecfg-Add-checkbox-to-enable-disable-EAX-support.patch
@@ -1,32 +1,32 @@
-From b3d074d58d20553723ae1adb6d84b34c73f038a8 Mon Sep 17 00:00:00 2001
+From 8d28215cb3db9c00dde12aaff5e67e50c2746b42 Mon Sep 17 00:00:00 2001
 From: Mark Harmstone <mark@harmstone.com>
 Date: Sun, 5 Apr 2015 14:16:11 +0100
-Subject: [PATCH] winecfg: Add checkbox to enable/disable EAX support.
+Subject: [PATCH 2/4] winecfg: Add checkbox to enable/disable EAX support.
 
 ---
  programs/winecfg/resource.h |  1 +
- programs/winecfg/staging.c  | 21 +++++++++++++++++++++
+ programs/winecfg/staging.c  | 20 ++++++++++++++++++++
  programs/winecfg/winecfg.rc |  1 +
- 3 files changed, 23 insertions(+)
+ 3 files changed, 22 insertions(+)
 
 diff --git a/programs/winecfg/resource.h b/programs/winecfg/resource.h
-index 17378655db6..27841f28135 100644
+index f9f71adfcf6..442e3cb7e4d 100644
 --- a/programs/winecfg/resource.h
 +++ b/programs/winecfg/resource.h
-@@ -215,6 +215,7 @@
+@@ -217,6 +217,7 @@
+ 
  /* Staging tab */
  #define IDC_ENABLE_CSMT                 9001
- #define IDC_ENABLE_VAAPI                9002
-+#define IDC_ENABLE_EAX                  9003
++#define IDC_ENABLE_EAX                  9002
  
  /* About tab */
  #define IDC_ABT_OWNER                8432
 diff --git a/programs/winecfg/staging.c b/programs/winecfg/staging.c
-index 3ba1e618bb3..5742187a9ff 100644
+index 0bd6e1741a7..1fd2ade7011 100644
 --- a/programs/winecfg/staging.c
 +++ b/programs/winecfg/staging.c
-@@ -58,10 +58,27 @@ static void vaapi_set(BOOL status)
-     set_reg_key(config_key, keypath(L"DXVA2"), L"backend", status ? L"va" : NULL);
+@@ -42,10 +42,26 @@ static void csmt_set(BOOL status)
+     set_reg_key_dword(config_key, L"Direct3D", L"csmt", status);
  }
  
 +/*
@@ -44,17 +44,16 @@ index 3ba1e618bb3..5742187a9ff 100644
 +{
 +    set_reg_key(config_key, keypath(L"DirectSound"), L"EAXEnabled", status ? L"Y" : L"N");
 +}
-+
+ 
  static void load_staging_settings(HWND dialog)
  {
      CheckDlgButton(dialog, IDC_ENABLE_CSMT, csmt_get() ? BST_CHECKED : BST_UNCHECKED);
-     CheckDlgButton(dialog, IDC_ENABLE_VAAPI, vaapi_get() ? BST_CHECKED : BST_UNCHECKED);
 +    CheckDlgButton(dialog, IDC_ENABLE_EAX, eax_get() ? BST_CHECKED : BST_UNCHECKED);
  }
  
  INT_PTR CALLBACK StagingDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
-@@ -95,6 +112,10 @@ INT_PTR CALLBACK StagingDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lPar
-             vaapi_set(IsDlgButtonChecked(hDlg, IDC_ENABLE_VAAPI) == BST_CHECKED);
+@@ -75,6 +91,10 @@ INT_PTR CALLBACK StagingDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lPar
+             csmt_set(IsDlgButtonChecked(hDlg, IDC_ENABLE_CSMT) == BST_CHECKED);
              SendMessageW(GetParent(hDlg), PSM_CHANGED, 0, 0);
              return TRUE;
 +        case IDC_ENABLE_EAX:
@@ -65,17 +64,17 @@ index 3ba1e618bb3..5742187a9ff 100644
          break;
      }
 diff --git a/programs/winecfg/winecfg.rc b/programs/winecfg/winecfg.rc
-index eafbdd6cd67..2e91285c0cc 100644
+index 65aeb6986df..9054454acf6 100644
 --- a/programs/winecfg/winecfg.rc
 +++ b/programs/winecfg/winecfg.rc
-@@ -319,6 +319,7 @@ BEGIN
+@@ -326,6 +326,7 @@ BEGIN
+     GROUPBOX    "Staging settings",IDC_STATIC,8,4,244,210
      LTEXT       "The following settings are experimental and may break stuff!\nMake sure to reset them again in case of a problem.",IDC_STATIC,16,16,230,16
      CONTROL     "Enable &CSMT for better graphic performance (deprecated)",IDC_ENABLE_CSMT,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,16,40,230,8
-     CONTROL     "Enable &VAAPI as backend for DXVA2 GPU decoding",IDC_ENABLE_VAAPI,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,16,55,230,8
-+    CONTROL     "Enable Environmental Audio E&xtensions (EAX)",IDC_ENABLE_EAX,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,16,70,230,8
++    CONTROL     "Enable Environmental Audio E&xtensions (EAX)",IDC_ENABLE_EAX,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,16,55,230,8
  END
  
  LANGUAGE LANG_NEUTRAL, SUBLANG_NEUTRAL
 -- 
-2.33.0
+2.43.0
 
diff --git a/patches/winecfg-Staging/0004-winecfg-Add-checkbox-to-enable-disable-HideWineExpor.patch b/patches/winecfg-Staging/0004-winecfg-Add-checkbox-to-enable-disable-HideWineExpor.patch
index c3e7d118..f3347738 100644
--- a/patches/winecfg-Staging/0004-winecfg-Add-checkbox-to-enable-disable-HideWineExpor.patch
+++ b/patches/winecfg-Staging/0004-winecfg-Add-checkbox-to-enable-disable-HideWineExpor.patch
@@ -1,7 +1,7 @@
-From 55896a1a320b28154196994d872b591073b08be7 Mon Sep 17 00:00:00 2001
+From 50d12de7c38e0d3f52a2dcad03e1ad545e5dfcae Mon Sep 17 00:00:00 2001
 From: Sebastian Lackner <sebastian@fds-team.de>
 Date: Sat, 30 May 2015 02:23:44 +0200
-Subject: [PATCH] winecfg: Add checkbox to enable/disable HideWineExports
+Subject: [PATCH 3/4] winecfg: Add checkbox to enable/disable HideWineExports
  registry key.
 
 ---
@@ -11,22 +11,22 @@ Subject: [PATCH] winecfg: Add checkbox to enable/disable HideWineExports
  3 files changed, 24 insertions(+)
 
 diff --git a/programs/winecfg/resource.h b/programs/winecfg/resource.h
-index 27841f28135..01d31f6c8dd 100644
+index 442e3cb7e4d..61ed229ff71 100644
 --- a/programs/winecfg/resource.h
 +++ b/programs/winecfg/resource.h
-@@ -216,6 +216,7 @@
+@@ -218,6 +218,7 @@
+ /* Staging tab */
  #define IDC_ENABLE_CSMT                 9001
- #define IDC_ENABLE_VAAPI                9002
- #define IDC_ENABLE_EAX                  9003
-+#define IDC_ENABLE_HIDEWINE             9004
+ #define IDC_ENABLE_EAX                  9002
++#define IDC_ENABLE_HIDEWINE             9003
  
  /* About tab */
  #define IDC_ABT_OWNER                8432
 diff --git a/programs/winecfg/staging.c b/programs/winecfg/staging.c
-index 5742187a9ff..13d0fa2ecb0 100644
+index 1fd2ade7011..69dc23c91d3 100644
 --- a/programs/winecfg/staging.c
 +++ b/programs/winecfg/staging.c
-@@ -74,11 +74,29 @@ static void eax_set(BOOL status)
+@@ -58,10 +58,28 @@ static void eax_set(BOOL status)
      set_reg_key(config_key, keypath(L"DirectSound"), L"EAXEnabled", status ? L"Y" : L"N");
  }
  
@@ -50,13 +50,12 @@ index 5742187a9ff..13d0fa2ecb0 100644
  static void load_staging_settings(HWND dialog)
  {
      CheckDlgButton(dialog, IDC_ENABLE_CSMT, csmt_get() ? BST_CHECKED : BST_UNCHECKED);
-     CheckDlgButton(dialog, IDC_ENABLE_VAAPI, vaapi_get() ? BST_CHECKED : BST_UNCHECKED);
      CheckDlgButton(dialog, IDC_ENABLE_EAX, eax_get() ? BST_CHECKED : BST_UNCHECKED);
 +    CheckDlgButton(dialog, IDC_ENABLE_HIDEWINE, hidewine_get() ? BST_CHECKED : BST_UNCHECKED);
  }
  
  INT_PTR CALLBACK StagingDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
-@@ -116,6 +134,10 @@ INT_PTR CALLBACK StagingDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lPar
+@@ -95,6 +113,10 @@ INT_PTR CALLBACK StagingDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lPar
              eax_set(IsDlgButtonChecked(hDlg, IDC_ENABLE_EAX) == BST_CHECKED);
              SendMessageW(GetParent(hDlg), PSM_CHANGED, 0, 0);
              return TRUE;
@@ -68,17 +67,17 @@ index 5742187a9ff..13d0fa2ecb0 100644
          break;
      }
 diff --git a/programs/winecfg/winecfg.rc b/programs/winecfg/winecfg.rc
-index 2e91285c0cc..ead9a54d5d2 100644
+index 9054454acf6..0ddd0fd2aea 100644
 --- a/programs/winecfg/winecfg.rc
 +++ b/programs/winecfg/winecfg.rc
-@@ -320,6 +320,7 @@ BEGIN
+@@ -327,6 +327,7 @@ BEGIN
+     LTEXT       "The following settings are experimental and may break stuff!\nMake sure to reset them again in case of a problem.",IDC_STATIC,16,16,230,16
      CONTROL     "Enable &CSMT for better graphic performance (deprecated)",IDC_ENABLE_CSMT,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,16,40,230,8
-     CONTROL     "Enable &VAAPI as backend for DXVA2 GPU decoding",IDC_ENABLE_VAAPI,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,16,55,230,8
-     CONTROL     "Enable Environmental Audio E&xtensions (EAX)",IDC_ENABLE_EAX,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,16,70,230,8
-+    CONTROL     "&Hide Wine version from applications",IDC_ENABLE_HIDEWINE,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,16,85,230,8
+     CONTROL     "Enable Environmental Audio E&xtensions (EAX)",IDC_ENABLE_EAX,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,16,55,230,8
++    CONTROL     "&Hide Wine version from applications",IDC_ENABLE_HIDEWINE,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,16,70,230,8
  END
  
  LANGUAGE LANG_NEUTRAL, SUBLANG_NEUTRAL
 -- 
-2.33.0
+2.43.0
 
diff --git a/patches/winecfg-Staging/0005-winecfg-Add-option-to-enable-disable-GTK3-theming.patch b/patches/winecfg-Staging/0005-winecfg-Add-option-to-enable-disable-GTK3-theming.patch
deleted file mode 100644
index 909deb01..00000000
--- a/patches/winecfg-Staging/0005-winecfg-Add-option-to-enable-disable-GTK3-theming.patch
+++ /dev/null
@@ -1,83 +0,0 @@
-From 99b2ab3b3885000f3669de87a5298f7e2a221ca4 Mon Sep 17 00:00:00 2001
-From: =?UTF-8?q?Michael=20M=C3=BCller?= <michael@fds-team.de>
-Date: Sun, 9 Aug 2015 18:01:11 +0200
-Subject: [PATCH] winecfg: Add option to enable/disable GTK3 theming.
-
----
- programs/winecfg/resource.h |  1 +
- programs/winecfg/staging.c  | 20 ++++++++++++++++++++
- programs/winecfg/winecfg.rc |  1 +
- 3 files changed, 22 insertions(+)
-
-diff --git a/programs/winecfg/resource.h b/programs/winecfg/resource.h
-index 01d31f6c8dd..d77f6a23a5a 100644
---- a/programs/winecfg/resource.h
-+++ b/programs/winecfg/resource.h
-@@ -217,6 +217,7 @@
- #define IDC_ENABLE_VAAPI                9002
- #define IDC_ENABLE_EAX                  9003
- #define IDC_ENABLE_HIDEWINE             9004
-+#define IDC_ENABLE_GTK3                 9005
- 
- /* About tab */
- #define IDC_ABT_OWNER                8432
-diff --git a/programs/winecfg/staging.c b/programs/winecfg/staging.c
-index 13d0fa2ecb0..56dbda33cc9 100644
---- a/programs/winecfg/staging.c
-+++ b/programs/winecfg/staging.c
-@@ -90,6 +90,21 @@ static void hidewine_set(BOOL status)
-     set_reg_key(config_key, keypath(L""), L"HideWineExports", status ? L"Y" : L"N");
- }
- 
-+/*
-+ * GTK3
-+ */
-+static BOOL gtk3_get(void)
-+{
-+    BOOL ret;
-+    WCHAR *value = get_reg_key(config_key, keypath(L""), L"ThemeEngine", NULL);
-+    ret = (value && !wcsicmp(value, L"GTK"));
-+    free(value);
-+    return ret;
-+}
-+static void gtk3_set(BOOL status)
-+{
-+    set_reg_key(config_key, keypath(L""), L"ThemeEngine", status ? L"GTK" : NULL);
-+}
- 
- static void load_staging_settings(HWND dialog)
- {
-@@ -97,6 +112,7 @@ static void load_staging_settings(HWND dialog)
-     CheckDlgButton(dialog, IDC_ENABLE_VAAPI, vaapi_get() ? BST_CHECKED : BST_UNCHECKED);
-     CheckDlgButton(dialog, IDC_ENABLE_EAX, eax_get() ? BST_CHECKED : BST_UNCHECKED);
-     CheckDlgButton(dialog, IDC_ENABLE_HIDEWINE, hidewine_get() ? BST_CHECKED : BST_UNCHECKED);
-+    CheckDlgButton(dialog, IDC_ENABLE_GTK3, gtk3_get() ? BST_CHECKED : BST_UNCHECKED);
- }
- 
- INT_PTR CALLBACK StagingDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
-@@ -138,6 +154,10 @@ INT_PTR CALLBACK StagingDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lPar
-             hidewine_set(IsDlgButtonChecked(hDlg, IDC_ENABLE_HIDEWINE) == BST_CHECKED);
-             SendMessageW(GetParent(hDlg), PSM_CHANGED, 0, 0);
-             return TRUE;
-+        case IDC_ENABLE_GTK3:
-+            gtk3_set(IsDlgButtonChecked(hDlg, IDC_ENABLE_GTK3) == BST_CHECKED);
-+            SendMessageW(GetParent(hDlg), PSM_CHANGED, 0, 0);
-+            return TRUE;
-         }
-         break;
-     }
-diff --git a/programs/winecfg/winecfg.rc b/programs/winecfg/winecfg.rc
-index ead9a54d5d2..738c4702aa3 100644
---- a/programs/winecfg/winecfg.rc
-+++ b/programs/winecfg/winecfg.rc
-@@ -321,6 +321,7 @@ BEGIN
-     CONTROL     "Enable &VAAPI as backend for DXVA2 GPU decoding",IDC_ENABLE_VAAPI,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,16,55,230,8
-     CONTROL     "Enable Environmental Audio E&xtensions (EAX)",IDC_ENABLE_EAX,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,16,70,230,8
-     CONTROL     "&Hide Wine version from applications",IDC_ENABLE_HIDEWINE,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,16,85,230,8
-+    CONTROL     "Enable &GTK3 Theming",IDC_ENABLE_GTK3,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,16,100,230,8
- END
- 
- LANGUAGE LANG_NEUTRAL, SUBLANG_NEUTRAL
--- 
-2.33.0
-
diff --git a/patches/winex11-Fixed-scancodes/0001-winecfg-Move-input-config-options-to-a-dedicated-tab.patch b/patches/winex11-Fixed-scancodes/0001-winecfg-Move-input-config-options-to-a-dedicated-tab.patch
index e6a7e7cb..1ce5c0a7 100644
--- a/patches/winex11-Fixed-scancodes/0001-winecfg-Move-input-config-options-to-a-dedicated-tab.patch
+++ b/patches/winex11-Fixed-scancodes/0001-winecfg-Move-input-config-options-to-a-dedicated-tab.patch
@@ -1,7 +1,7 @@
-From b97b584a775bf22c19c94064a7321770764cf25e Mon Sep 17 00:00:00 2001
+From 59dbf02a9eb2611d68f1721efa932ca69df11dd9 Mon Sep 17 00:00:00 2001
 From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
 Date: Thu, 5 Jan 2023 21:16:38 +0100
-Subject: [PATCH] winecfg: Move input config options to a dedicated tab.
+Subject: [PATCH 4/4] winecfg: Move input config options to a dedicated tab.
 
 Wine-Bug: https://bugs.winehq.org/show_bug.cgi?id=30984
 Wine-Bug: https://bugs.winehq.org/show_bug.cgi?id=45605
@@ -18,7 +18,7 @@ Wine-Bug: https://bugs.winehq.org/show_bug.cgi?id=45605
  create mode 100644 programs/winecfg/input.c
 
 diff --git a/MAINTAINERS b/MAINTAINERS
-index dc5c85cc4ec..a5902235be8 100644
+index 4bab36bfdf9..f326dcc2c39 100644
 --- a/MAINTAINERS
 +++ b/MAINTAINERS
 @@ -182,6 +182,7 @@ F:	dlls/user32/input.c
@@ -153,10 +153,10 @@ index 00000000000..115161b9040
 +    return FALSE;
 +}
 diff --git a/programs/winecfg/main.c b/programs/winecfg/main.c
-index de5340c721f..819aaaf61e1 100644
+index afecfd664a9..b733b11be5e 100644
 --- a/programs/winecfg/main.c
 +++ b/programs/winecfg/main.c
-@@ -57,7 +57,7 @@ PropSheetCallback (HWND hWnd, UINT uMsg, LPARAM lParam)
+@@ -58,7 +58,7 @@ PropSheetCallback (HWND hWnd, UINT uMsg, LPARAM lParam)
      return 0;
  }
  
@@ -165,7 +165,7 @@ index de5340c721f..819aaaf61e1 100644
  
  static INT_PTR
  doPropertySheet (HINSTANCE hInstance, HWND hOwner)
-@@ -148,6 +148,16 @@ doPropertySheet (HINSTANCE hInstance, HWND hOwner)
+@@ -149,6 +149,16 @@ doPropertySheet (HINSTANCE hInstance, HWND hOwner)
      psp[pg].lParam = 0;
      pg++;
  
@@ -183,7 +183,7 @@ index de5340c721f..819aaaf61e1 100644
       * Fill out the (General) PROPSHEETPAGE data structure 
       * for the property sheet
 diff --git a/programs/winecfg/resource.h b/programs/winecfg/resource.h
-index c0d7adadcc1..6e2953c0d70 100644
+index 61ed229ff71..fca60ab9e44 100644
 --- a/programs/winecfg/resource.h
 +++ b/programs/winecfg/resource.h
 @@ -46,6 +46,7 @@
@@ -210,7 +210,7 @@ index c0d7adadcc1..6e2953c0d70 100644
  
  #define IDC_RES_TRACKBAR                1107
  #define IDC_RES_DPIEDIT                 1108
-@@ -230,3 +231,6 @@
+@@ -228,3 +229,6 @@
  #define IDC_ABT_TITLE_TEXT           8436
  #define IDC_ABT_WEB_LINK             8437
  #define IDC_ABT_LICENSE_TEXT         8438
@@ -240,7 +240,7 @@ index d4fedff5afb..b83234470c1 100644
  /* Windows version management */
  BOOL set_winver_from_string(const WCHAR *version);
 diff --git a/programs/winecfg/winecfg.rc b/programs/winecfg/winecfg.rc
-index 428c477413c..1231e5319c5 100644
+index 0ddd0fd2aea..aa890124571 100644
 --- a/programs/winecfg/winecfg.rc
 +++ b/programs/winecfg/winecfg.rc
 @@ -40,6 +40,7 @@ BEGIN
@@ -288,8 +288,8 @@ index 428c477413c..1231e5319c5 100644
  END
  
  IDD_DLLCFG DIALOG  0, 0, 260, 220
-@@ -332,6 +332,14 @@ BEGIN
-     CONTROL     "Enable &GTK3 Theming",IDC_ENABLE_GTK3,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,16,100,230,8
+@@ -330,6 +330,14 @@ BEGIN
+     CONTROL     "&Hide Wine version from applications",IDC_ENABLE_HIDEWINE,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,16,70,230,8
  END
  
 +IDD_INPUT_CONFIG DIALOG  0, 0, 260, 220
@@ -304,10 +304,10 @@ index 428c477413c..1231e5319c5 100644
  
  /* @makedep: winecfg.ico */
 diff --git a/programs/winecfg/x11drvdlg.c b/programs/winecfg/x11drvdlg.c
-index 215cd6534a2..cd7b7552a1e 100644
+index aea52717a78..2f739564c23 100644
 --- a/programs/winecfg/x11drvdlg.c
 +++ b/programs/winecfg/x11drvdlg.c
-@@ -47,7 +47,7 @@ static const UINT dpi_values[] = { 96, 120, 144, 168, 192, 216, 240, 288, 336, 3
+@@ -46,7 +46,7 @@ static const UINT dpi_values[] = { 96, 120, 144, 168, 192, 216, 240, 288, 336, 3
  static BOOL updating_ui;
  
  /* convert the x11 desktop key to the new explorer config */
@@ -316,7 +316,7 @@ index 215cd6534a2..cd7b7552a1e 100644
  {
      WCHAR *buf;
  
-@@ -139,13 +139,6 @@ static void init_dialog(HWND dialog)
+@@ -138,13 +138,6 @@ static void init_dialog(HWND dialog)
          SendDlgItemMessageW(dialog, IDC_DESKTOP_HEIGHT, EM_LIMITTEXT, RES_MAXLEN, 0);
      }
  
@@ -330,7 +330,7 @@ index 215cd6534a2..cd7b7552a1e 100644
      buf = get_reg_key(config_key, keypath(L"X11 Driver"), L"Managed", L"Y");
      if (IS_OPTION_TRUE(*buf))
  	CheckDlgButton(dialog, IDC_ENABLE_MANAGED, BST_CHECKED);
-@@ -220,14 +213,6 @@ static void on_enable_decorated_clicked(HWND dialog) {
+@@ -219,14 +212,6 @@ static void on_enable_decorated_clicked(HWND dialog) {
      }
  }
  
@@ -345,7 +345,7 @@ index 215cd6534a2..cd7b7552a1e 100644
  static INT read_logpixels_reg(void)
  {
      DWORD dwLogPixels;
-@@ -383,7 +368,6 @@ GraphDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
+@@ -382,7 +367,6 @@ GraphDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
  			case IDC_ENABLE_DESKTOP: on_enable_desktop_clicked(hDlg); break;
                          case IDC_ENABLE_MANAGED: on_enable_managed_clicked(hDlg); break;
                          case IDC_ENABLE_DECORATED: on_enable_decorated_clicked(hDlg); break;
@@ -354,5 +354,5 @@ index 215cd6534a2..cd7b7552a1e 100644
  		    break;
  		}
 -- 
-2.42.0
+2.43.0
 
-- 
2.43.0